#include <harkio2/harkconfig/HarkConfigFileXMLWriter.hpp>

#include <harkio2/harkconfig/HarkConfigFile.hpp>
#include <harkio2/NotImplemented.hpp>

// load Helper implementation.
#include "HarkConfigFileXMLWriter/Helper.cpp"

namespace harkio2
{
namespace harkconfig
{

HarkConfigFileXMLWriter::HarkConfigFileXMLWriter(std::ostream& out)
    : helper(new Helper(*this)), out(out)
{ }

HarkConfigFileXMLWriter::~HarkConfigFileXMLWriter()
{ }

void HarkConfigFileXMLWriter::Write(boost::shared_ptr<harkio2::harkconfig::HarkConfigFile> data) throw (harkio2::InvalidHarkFile)
{
    if (data)
    {
        Write(*data);
    }
}

void HarkConfigFileXMLWriter::Write(const harkio2::harkconfig::HarkConfigFile& o) throw (harkio2::InvalidHarkFile)
{
    helper->WriteConfigFile(o);
}
void HarkConfigFileXMLWriter::Write(const harkio2::harkconfig::ImpulseResponseListFile1_0& o) throw (harkio2::InvalidHarkFile)
{
    throw harkio2::NotImplemented("Not implemented: HarkConfigFileXMLWriter::Write(const harkio2::harkconfig::ImpulseResponseListFile1_0&)");
}
void HarkConfigFileXMLWriter::Write(const harkio2::harkconfig::ImpulseResponseListFile2_0& o) throw (harkio2::InvalidHarkFile)
{
    helper->Write(o);
}
void HarkConfigFileXMLWriter::Write(const harkio2::harkconfig::TSPListFile1_0& o) throw (harkio2::InvalidHarkFile)
{
    throw harkio2::NotImplemented("Not implemented: HarkConfigFileXMLWriter::Write(const harkio2::harkconfig::TSPListFile1_0&)");
}
void HarkConfigFileXMLWriter::Write(const harkio2::harkconfig::TSPListFile2_0& o) throw (harkio2::InvalidHarkFile)
{
    helper->Write(o);
}
void HarkConfigFileXMLWriter::Write(const harkio2::harkconfig::MicArrayLocationFile2_0& o) throw (harkio2::InvalidHarkFile)
{
    helper->Write(o);
}
void HarkConfigFileXMLWriter::Write(const harkio2::harkconfig::NoiseLocationFile2_0& o) throw (harkio2::InvalidHarkFile)
{
    helper->Write(o);
}

}
}

